//---------------------------------------------------------------------------
#include <vcl\condefs.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>
#include <iostream.h>

#pragma hdrstop
//---------------------------------------------------------------------------
USERES("isocalc.res");
//---------------------------------------------------------------------------
int main(int argc, char **argv)
{
  /*	Generates ALL possible non equivalent isomers of a cyclic consisting of ncyc monomers
      and nmon different types of monomers. x-y building block architecture
      Count number of isomers with targ_c[i] monomers of type i */
  // initialize
  int ncyc,nmon; // number of monomers in the cyclic, no. of types of monomer
  int cyc[25]; // the make up of the cyclic
  int rot_cyc[25]; // rotated cyclic
  int targ_c[25]; // the target monomer composition
  int act_c[25]; // the actual monomers
  int count=0,totc=0,tot=0; // count of the number of isomers, total no. of isomers
  bool sym,match;
  for (int j=0;j<25;j++) {
  	cyc[j]=0;
    targ_c[j]=0;
    act_c[j]=0;
  }
  cout << "x-y system\n";
  cout << "Number of monomers in the cyclic? ";
  cin >> ncyc;
  cout << "How many types of monomers? ";
  cin >> nmon;
  if (ncyc==1 || ncyc>24 || nmon>24 || nmon<1) { cout << "\nValues not valid. Try again\n";getch();return 0; }
  for (int j=0;j<nmon-1;j++) {
  	cout << "No. of monomer " << j << " : ";
    cin >> targ_c[j];
    tot+=targ_c[j];
    if (tot>ncyc) { cout << "\nError. Too many monomers. Exiting"; getch(); return 0; }
  }
  targ_c[nmon-1]=ncyc-tot;
  cout << "No. of monomer " << (nmon-1) << " : " << targ_c[nmon-1];
  cout << "\nWorking...\n";
  int idx;
  do {
  	// apply rotation
    for (int i=0; i<ncyc;i++) rot_cyc[i]=cyc[i]; // make a copy of the cyclic
    sym=false;
    for (int i=1; i<ncyc; i++) {
    	rot_cyc[ncyc]=rot_cyc[0];
      for (int j=0; j<ncyc; j++) rot_cyc[j]=rot_cyc[j+1]; // be careful not to overrun array!
      for (int j=ncyc-1; j>=0; j--) {   // check whether this has been counted already
      	if (cyc[j]>rot_cyc[j]) { sym = true; break; }
        else if (cyc[j]<rot_cyc[j]) { sym = false; break; }
      }
      if (sym) break;
    }
    if (!sym) {
      totc++;
      for (int i=0; i<nmon; i++) act_c[i]=0;
    	for (int i=0; i<ncyc; i++) {
      	act_c[cyc[i]]++;  // count up number of each type of monomer
      }
      match=true;
      for (int i=0; i<nmon; i++) {
      	if (act_c[i]!=targ_c[i]) match=false;
      } // check for match
      if (match) {
      	count++;
     /*   for (int i=0; i<ncyc;i++) cout << cyc[i] << ',';
        cout << '\n';  // output the makeup of the cyclic    */
      }
    }
    // now increment the cyclic
    idx=0;
    while (idx<ncyc) {
    	cyc[idx]++;
      if (cyc[idx]==nmon) {
      	cyc[idx]=0;
        idx++;
      }
      else break;
    }
  } while (idx<ncyc);
  cout << "Total number of isomers: " << totc << '\n';
  cout << "Number of sequence isomers of required mass: " << count << '\n';
  cout << "Press any key to end.";
  getch();
	return 0;
}
//---------------------------------------------------------------------------
