//---------------------------------------------------------------------------
#include <vcl\condefs.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>
#include <iostream.h>
#include <fstream.h>
#pragma hdrstop
#define MAXMON 10
//---------------------------------------------------------------------------
USERES("mass.res");
//---------------------------------------------------------------------------
// Combinatorial mass calculator. J.E.Redman 1999.
int total(int*,int);
int main(int argc, char **argv)
{
  int n=0; // number of types of monomer
  int maxc=0; // maximum number of monomers in the cyclic
  int p[MAXMON]; // number of each monomers in the cyclic
  int idx;
  float monmass[MAXMON]; // masses of monomers
  float mass; // mass of oligomer
  cout << "No. of types of monomer (max 10)? ";
  do { cin >> n; } while (n > MAXMON);
  for (int i=0;i<n;i++) {
  	cout << "Mass of monomer " << (i+1) << "? ";
    cin >> monmass[i];
  }
  cout << "Maximum no. of monomers in a cyclic? ";
  cin >> maxc;
  ofstream out("out.csv");
  for (int i=1;i<=n;i++) out << "Mon. " << i << ',';
  n--; // only need worry about n-1 monomers
  out << "M,[M+H]+,[M]2+\n";
  for (int c=1;c<=maxc;c++) {
    out << '\n' << c << "mers\n";
  	for (int i=0;i<n;i++) p[i]=0;
  	do {
  		out << (c-total(p,n));
      mass = (c-total(p,n))*monmass[0];
  		for (int i=0;i<n;i++) {
      	out << ',' << p[i];
        mass+=p[i]*monmass[i+1];
      };
      out << ',' << mass<< ',' << (mass+1) << ',' << (mass+1)/2;
    	out << '\n';
    	idx=0;
    	do {
    		p[idx]++;
      	if (total(p,n)>c) {
      		p[idx]=0;
        	idx++;
      	}
      	else break;
    	} while (idx<n);
  	} while (idx<n);
  }
  cout << "\aDone\nPress any key...";
  out.close();
  getch();
	return 0;
}

int total(int *p,int n)
{
  int total=0;
	for (int i=0;i<n;i++) total+=p[i];
  return total;
}
//---------------------------------------------------------------------------
